import { Bounds } from './bounds';
import { Quadtree } from './quadtree';
export interface qTreeOptions {
    maxDepth?: number;
    maxChildren?: number;
}
export declare class qTree<T extends object> implements Quadtree<T> {
    private readonly depth;
    private readonly maxChildren;
    private readonly maxDepth;
    private readonly items;
    private readonly boundsFn;
    private readonly quadCache;
    private readonly childAreas;
    private readonly children;
    private isSplit;
    constructor([x0, y0, x1, y1]: Readonly<Bounds>, options: qTreeOptions, boundFn: (item: T) => Bounds, quadCache: WeakMap<T, qTree<T>>, depth?: number);
    clear(): void;
    insert(item: Readonly<T>): void;
    private tryChildInsert;
    remove(item: Readonly<T>): boolean;
    collectAll(result?: Readonly<T>[]): Readonly<T>[];
    collect(area: Readonly<Bounds>, result?: Readonly<T>[]): Readonly<T>[];
    all(): Generator<Readonly<T>, void, undefined>;
    search(area: Readonly<Bounds>): Generator<Readonly<T>, void, undefined>;
    size(): number;
}
//# sourceMappingURL=q-tree.d.ts.map